'Vejr-dk version 3.4
'Dette script henter Vejr Information fra weather.noaa.gov
'den laver en temp file i din samurize folder, hvis du p et tidspunkt for problemer med scriptet s prve at slet den
'for fejl rapporter eller andre ting vedrrende scriptet, mail til limdul@samurize.dk
'hvis du ndrer i scriptet s send mig venligt den ndrede version, samt lad denne tekst st.
'Lavet ud fra NOOAWeather v2.3 By FMJ
'Lavet af LimDul, med hjlp fra FMJ og MKS
' NOOAWeather v2.3, (C) By FMJ 2002-12-12
' Vejr-dk  v3.4,    (C) By LimDul 2003-02-01
' ndret sledes scriptet ikke fejler nr det ikke mles en vindhastighed(Calm), dvs. at der er vindstille.


'Log:

'3.4 ndret mden tmp filen hentets og gemmes p (Scriptet bruger nu MSXML 3.0+, s det skulle ogs virke gennem Proxey (bruger IE instillinger) 
' Hvis du ikke har XML 3.0 s kan det hente her: http://www.microsoft.com/downloads/release.asp?ReleaseID=37176


Dim geturl,US,MS,tp,CRLF,Degrees,Fahrenheit,MTimer,savePath,FileName,url,fso,OfflineMsg,RangeFByte,RangeLByte,TmpFilNavn,TmpFilFolder

' ================ RET LINJERNE HERUNDER!! ========================

' g ind p http://weather.noaa.gov/weather/DK_cc.html og find liken til din by og ret p p linjen herunder til din link.
' skal vre samme format med nogen bogstaver.html til slutning og http://weather.noaa.gov/weather/current/ i starten.

url = "http://weather.noaa.gov/weather/current/EKOD.html" 	'RET HER!!!!


' Instillinger:
' -------------
TmpFilNavn	= "vejr-dk.tmp"				'Navnet p temp filen.
TmpFilFolder	= "C:\Program Files\SSamurize\" 	'Steder hvor temp filen skal gemmes. OBS! SKAL slutte med \ 

US      	= False 				'True = Amerkansk standart, False = Dansk standart. (miles eller kilometer i timen, Fahrenheit eller Censius, Miles eller km)
MS      	= True 					'True = Viser vinden i m/s False = kilometer i timen.
OfflineBesked 	= "Der kan ikke skabes kontakt til weather.noaa.gov" 'Tekst hvis der ikke kan skabes kontakt til vejr siden













' ======================== .VBS KODE RET IKKE NOGET HERUNDER!!!! ============================================================













CRLF 		= Chr(10)	'carriage return
Degrees 	= "C" 		'degrees symbol
Fahrenheit 	= "F" 		'Fahrenheit symbol
FileName  	= TmpFilNavn
OfflineMsg 	= OfflineBesked
RangeFByte 	= 5500
RangeLByte 	= 26068
MTimer 		= 60


' create and set the temp-path.
set fso=CreateObject("Scripting.FileSystemObject")
savePath = TmpFilFolder
If Not fso.FolderExists(savePath) then 
	fso.CreateFolder(savePath)
End If

' example main web-fetching function.
Function HentData
	dim html,fs,f
	set fs=CreateObject("Scripting.FileSystemObject")
	if not fs.fileexists(savePath & FileName) then ' check if the file exists.
		html = BinToText(GetHTMLBin(url), 35000) ' and if not retrieve content
		WriteFile savePath & FileName, html ' then create/save the temp file.
	end if

	if TimeDiff(savePath & FileName) > MTimer then ' check how old the temp-file is
		html = BinToText(GetHTMLBin(url), 35000) ' and if its too old, then retrieve content again
		WriteFile savePath & FileName, html ' then write/save to temp file.
	end if

	html = ReadFile(savePath & FileName) ' otherwise we just read the temp file contents. :)

' do stuff with html here

	'HentData = html
	HentData = "Temp filen er hentet!"
End Function

Function SidstOpdateret
	nooadato = GetHTMLValue("</SELECT><BR>", "</FORM></FONT>", "")	'Henter tiden i US tidsformat og UTC tidszone
	If len(nooadato) > 0 Then
		nooadato = replace(nooadato, CRLF, "") 
	
		Year1  = Mid(nooadato, 2, 4)			'Henter ret
		Month1 = Mid(nooadato, 7, 2)			'Henter Mned
		Day1   = Mid(nooadato, 10, 2)			'Henter dag
		Hour1  = Mid(nooadato, 13, 2)			'Henter time (UTC Tidszone)
		Minut1 = Mid(nooadato, 15, 2)			'Henter min
		
		Select Case Month1
      
      		Case "01"       Month1 = "januar"		' Udskifter mneds nummer med mneds navn
      		Case "02"       Month1 = "februar"
      		Case "03"       Month1 = "marts"
      		Case "04"       Month1 = "april"
      		Case "05"       Month1 = "may"
      		Case "06"       Month1 = "juni"
      		Case "07"       Month1 = "juli"
      		Case "08"       Month1 = "august"
      		Case "09"       Month1 = "september"
      		Case "10"       Month1 = "october"
      		Case "11"       Month1 = "november"
      		Case "12"       Month1 = "december"
      		Case Else       Month1 = "ukendt mned"
   		End Select
		
		If Hour1 = 24 Then				' Stter timen til dansk tidszone
			Hour2 = 00+1		
		Else
			If Hour1+1 < 24 Then
				Hour2 = Hour1+1
			Else
				If Hour1+1 > 24 Then
					Hour2 = 00+((Hour1+1)-24)
				Else
					Hour2 = 00
				End If
			End If
	
		End If
		SidstOpdateret = Day1 & ". " & Month1 & " " & Year1 & " - kl. " & Hour2 & ":" & Minut1		'Samler tiden i dansk tidsformat
	Else
	 	SidstOpdateret = "N/A"		'Besked hvis tiden ikke findes
	End If
End Function

Function Omraade
	Omraade = GetHTMLValue("Current Weather Conditions:<BR>","</B>", "")
	If len(Omraade) = 0 Then
		Omraade = "By ikke fundet"
	End If
	Omraade = replace(Omraade, "Denmark", "Danmark")
	Omraade = replace(Omraade, "Odense / Beldringe", "Odense")
	Omraade = replace(Omraade, "Koebenhavn / Kastrup", "Kbenhavn")
	Omraade = replace(Omraade, "Vaerloese", "Vrlse")
	Omraade = replace(Omraade, "Soervaag / Vagar", "Srvg")
End Function


Function Temperatur
	Temperatur = GetHTMLValue("> Temperature </FONT></FONT></B></TD>","</FONT></TD>", "")
       	If Temperatur <> "N/A" Then
	 	temppos = instrrev(Temperatur, "> ")+3
	 	Temperatur = Mid(Temperatur, temppos, len(Temperatur))
	 	Temperatur = replace(Temperatur, CRLF, "") 
         	If US = false then
	   		temppos = instrrev(Temperatur, "(")
	   		temppos2 = instrrev(Temperatur, " C)")
      	   		Temperatur = Mid(Temperatur, temppos, temppos2)
   	   		Temperatur = replace(Temperatur, "C", Degrees) 
   	   		Temperatur = replace(Temperatur, "(", "") 
   	   		Temperatur = replace(Temperatur, ")", "") 
	  	Else
	   		temppos = instrrev(Temperatur, "(")-1
      	   		Temperatur = Mid(Temperatur, 1, temppos)
   	   		Temperatur = replace(Temperatur, " F", Fahrenheit) 
   	  	End If
	Else
 	 	Temperatur = "N/A"
	End If
		Temperatur = replace(Temperatur, " C ", "")
		Temperatur = replace(Temperatur, " F ", "")
End Function


Function Vind
	Vind = GetHTMLValue("> Wind </FONT></FONT></B></TD>","</FONT>", "")
	If Vind <> "N/A" then
		temppos = instr(Vind, "> ")+2
		Vind = Mid(Vind, temppos, len(Vind))
	' Denne IF er tilfjet som tjekker p om der er vindstille	
		If trim(Vind) <> "Calm" then
	        	sign = instr(Vind, "MPH")+4
			If US = false then
	        		sign = instr(Vind, "MPH")+5
	       			spos = instr(Vind, "at ")+3
	        		chrs = instr(Vind, "MPH") - spos
				speed = Mid(Vind, spos, chrs)
				If MS = true then
					nspeed = round((speed * 1.609344) / 3.6)
					Vind = replace(Vind, speed, nspeed)
					Vind = replace(Vind, "MPH", " m/s ")
				Else 
					nspeed = round(speed * 1.609344)
					Vind = replace(Vind, speed, nspeed)
					Vind = replace(Vind, "MPH", " km/t")
				End if
			End If
			temppos = instr(Vind, "(")-1
			Vind1 = Mid(Vind, 1, temppos)
			temppos = instr(Vind, ")")+1
			Vind2 = Mid(Vind, temppos, (sign-temppos))
			Vind1 = replace(Vind1, " from the ", "")
			Vind2 = replace(Vind2, " at", "med")
			Vind2 = replace(Vind2, "  (", "")
					
			Select Case Vind1
	      
	      		Case "N "       Vind1 = "Nord"
	      		Case "S "       Vind1 = "Syd"
	      		Case "E "       Vind1 = "st"
	      		Case "W "       Vind1 = "Vest"
	      		Case "NE "      Vind1 = "Nordst"
	      		Case "NW "      Vind1 = "Nordvest"
	      		Case "SE "      Vind1 = "Sydst"
	      		Case "SW "      Vind1 = "Sydvest"
	      		Case "NNE "     Vind1 = "Nord-Nordst"
	      		Case "NNW "     Vind1 = "Nord-Nordvest"
	      		Case "SSE "     Vind1 = "Syd-Sydst"
	      		Case "SSW "     Vind1 = "Syd-Sydvest"
	      		Case "ENE "     Vind1 = "st-Nordst"
	      		Case "ENW "     Vind1 = "st-Nordvest"
	      		Case "WNE "     Vind1 = "Vest-Nordst"
	      		Case "WNW "     Vind1 = "Vest-Nordvest"
	      		Case "ESE "     Vind1 = "st-Sydst"
	      		Case "ESW "     Vind1 = "st-Sydvest"
	      		Case "WSE "     Vind1 = "Vest-Sydst"
	      		Case "WSW "     Vind1 = "Vest-Sydvest"
	      		Case Else       Vind1 = "Unkendt"
	   		End Select
	
			Vind = Vind1 & " " & Vind2

' Hvis der derimod er vindstille sttes Vind til "Vindstille
		Else
			Vind = "Vindstille"
		End If
	Else
        	Vind = "N/A"
	End If
		
End Function


Function Vindeffekt
	Vindeffekt = GetHTMLValue("> Windchill </FONT></FONT></B></TD>", "</FONT></TD>", "")
	If Vindeffekt <> "N/A" Then
		temppos = instrrev(Vindeffekt, "> ")+3
		Vindeffekt = Mid(Vindeffekt, temppos, len(Vindeffekt))
		Vindeffekt = replace(Vindeffekt, CRLF, "") 
		If US = false Then
			temppos = instrrev(Vindeffekt, "(")
			temppos2 = instrrev(Vindeffekt, " C)")
      			Vindeffekt = Mid(Vindeffekt, temppos, temppos2)
   			Vindeffekt = replace(Vindeffekt, "C", Degrees) 
   			Vindeffekt = replace(Vindeffekt, "(", "") 
   			Vindeffekt = replace(Vindeffekt, ")", "") 
		Else
			temppos = instrrev(Vindeffekt, "(")-1
      			Vindeffekt = Mid(Vindeffekt, 1, temppos)
   			Vindeffekt = replace(Vindeffekt, " F", Fahrenheit) 
   		End If
	Else
        	Vindeffekt = "N/A"
	End If
		Vindeffekt = replace(Vindeffekt, " C ", "")
		Vindeffekt = replace(Vindeffekt, " F ", "")
End Function


Function Luftfugtighed
	Luftfugtighed = GetHTMLValue("> Relative Humidity </FONT></FONT></B></TD>","</FONT></TD>", "")
	If Luftfugtighed <> "N/A" Then
		temppos = instrrev(Luftfugtighed, "> ")+3
		Luftfugtighed = Mid(Luftfugtighed, temppos, len(Luftfugtighed))
		Luftfugtighed = replace(Luftfugtighed, CRLF, " ") 
	Else
		Luftfugtighed = "N/A"
	End If
		Luftfugtighed = replace(Luftfugtighed, "%  ", "")
End Function


Function Dugpunkt
	Dugpunkt = GetHTMLValue("> Dew Point </FONT></FONT></B></TD>", "</FONT></TD>", "")
	If Dugpunkt <> "N/A" Then
		temppos = instrrev(Dugpunkt, "> ")+3
		Dugpunkt = Mid(Dugpunkt, temppos, len(Dugpunkt))
		Dugpunkt = replace(Dugpunkt, CRLF, "") 
		If US = false Then
			temppos = instrrev(Dugpunkt, "(")
			temppos2 = instrrev(Dugpunkt, " C)")
			Dugpunkt = Mid(Dugpunkt, temppos, temppos2)
   			Dugpunkt = replace(Dugpunkt, "C", Degrees) 
   			Dugpunkt= replace(Dugpunkt, "(", "") 
   			Dugpunkt = replace(Dugpunkt, ")", "") 
		Else
			temppos = instrrev(Dugpunkt, "(")-1
      			Dugpunkt = Mid(Dugpunkt, 1, temppos)
   			Dugpunkt = replace(Dugpunkt, " F", Fahrenheit) 
   		End If
	Else
		Dugpunkt = "N/A"
	End If
		Dugpunkt = replace(Dugpunkt, " C ", "")
End Function


Function Forhold
	Forhold = GetHTMLValue("> Sky conditions </FONT></FONT></B></TD>","</FONT></TD>", "")
	If Forhold <> "N/A" Then
	  	temppos = instrrev(Forhold, "> ")+3
	  	Forhold = Mid(Forhold, temppos, len(Forhold))
	  	Forhold = replace(Forhold, CRLF, "") 
	  	
	  	Select Case Forhold
	  	
	  	Case "clear "		Forhold = "Klart"
	  	Case "partly clear "	Forhold = "Delvist klart"
	  	Case "mostly clear "	Forhold = "Mest klart"
	  	Case "cloudy "		Forhold = "Overskyet"
	  	Case "overcast "	Forhold = "Overskyet"
	  	Case "partly cloudy "	Forhold = "Delvist skyet"
	  	Case "mostly cloudy "	Forhold = "Mest skyet"
	  	Case "snow "		Forhold = "Sne"
	  	Case "Son "		Forhold = "Sol"
	  	Case "obscured "	Forhold = "Tget"
	  	Case Else		Forhold = Forhold
	  	
		End Select
	  		  	
	Else
		Forhold = "N/A"
	End If
End Function


Function Tryk
	Tryk = GetHTMLValue("> Pressure (altimeter) </FONT></FONT></B></TD>","</FONT></TD>", "")
	If Tryk <> "N/A" Then
		temppos = instrrev(Tryk, "> ")+2
		Tryk = Mid(Tryk, temppos, len(Tryk))
		Tryk = replace(Tryk, CRLF, "") 
		If US = false Then
			temppos = instr(Tryk, "(")
			temppos2 = instrrev(Tryk, ")")
      			Tryk = Mid(Tryk, temppos, (temppos2-temppos))
   			Tryk= replace(Tryk, "(", "") 
   			Tryk = replace(Tryk, ")", "") 
		Else
			temppos = instrrev(Tryk, "(")-1
      			Tryk = Mid(Tryk, 1, temppos)
   		End If 
	Else
		Tryk = "N/A"
	End If
		Tryk = replace(Tryk, " hPa", "")
End Function


Function Sigtbarhed 
	Sigtbarhed = GetHTMLValue("> Visibility </FONT></FONT></B></TD>","</FONT></TD>", "") 
	If Sigtbarhed <> "N/A" Then
		temppos = instrrev(Sigtbarhed, "> ")+3
		Sigtbarhed = Mid(Sigtbarhed, temppos, len(Sigtbarhed))
		If US = false Then
			If Sigtbarhed <> "Unlimited miles" Then
        			If InStr(Sigtbarhed, "(") > 1 Then  
   					chrs = instrrev(Sigtbarhed, "mile(s)")-2
					vis = Mid(Sigtbarhed, chrs, 2) 
					nvis = round(vis * 1.6093) 
					Sigtbarhed = replace(Sigtbarhed, vis, nvis) 
					Sigtbarhed = replace(Sigtbarhed, "mile(s)", " km") 
				Else
					chrs = instrrev(Sigtbarhed, "mile")-2
					vis = Mid(Sigtbarhed, chrs, 2) 
					nvis = round(vis * 1.6093) 
					Sigtbarhed = replace(Sigtbarhed, vis, nvis) 
					Sigtbarhed = replace(Sigtbarhed, "mile", " km") 
				End If 
			End If
		End If 
		Sigtbarhed = replace(Sigtbarhed, "greater than", "Lngere end")
		Sigtbarhed = replace(Sigtbarhed, "less than", "Kortere end")
	Else 
		Sigtbarhed = "N/A"
	End If 
		Sigtbarhed  = replace(Sigtbarhed , " km ", "")
End Function


Function Vejr
	Vejr = GetHTMLValue("> Weather </FONT></FONT></B></TD>","</FONT></TD>", "")
 	If Vejr <> "N/A" then
		temppos = instrrev(Vejr, "> ")+3
		Vejr = Mid(Vejr, temppos, len(Vejr))
		Vejr = replace(Vejr, CRLF, " ") 
	Else
		Vejr = "N/A"
	End If
End Function

Function Icon
	Icon = Forhold
	If Icon <> "N/A" Then
		
		Select Case Icon
	  	
	  	Case "Klart"		Icon = "Q"
	  	Case "Delvist klart"	Icon = "R"
	  	Case "Mest klart"	Icon = "Q"
	  	Case "Overskyet"	Icon = "S"
	  	Case "Delvist skyet"	Icon = "R"
	  	Case "Mest skyet"	Icon = "S"
	  	Case "Sne"		Icon = "P"
	  	Case "Sol"		Icon = "Q"
	  	Case "Tget"		Icon = ""
	  	Case "Regn"		Icon = "B"
	  	Case "Lyn"		Icon = "E"
	  	Case "Storm"		Icon = "O"
	  	Case Else		Icon = ""
	  	
		End Select
		
	Else
		Icon = ""
	End If
End Function



Private Function GetHTMLValue(LeftBound,RightBound, htmlresult)

Set file_obj = CreateObject ("Scripting.FileSystemObject")
If (file_obj.FileExists(savePath & FileName)) Then
 Set file_path = file_obj.GetFile(savePath & FileName) ' Creates the connection to the file
 set file = file_path.OpenAsTextStream (1, -2) ' Opens the file for reading

 htmlresult = file.readall
 
 File.Close ' Closes the file
 Set file_path = nothing ' Resets variable
 Set file_obj = nothing ' Resets variable

 HtmlStart = InStr(HtmlResult, LeftBound) + Len(LeftBound)
 HtmlEnd = InStr(HtmlStart, HtmlResult, RightBound)

  If HtmlStart <> Len(LeftBound) And HtmlStart > 0 And HtmlEnd > 0 Then
   GetHTMLValue = Replace(Mid(HtmlResult, HtmlStart, HtmlEnd - HtmlStart ), "&nbsp;", " ")
  Else
   GetHTMLValue = "N/A"
  End If
Else
 GetHTMLValue = "N/A"
End If
End Function

Private Function TimeDiff(file)
	dim fs,f,diff
	set fs=CreateObject("Scripting.FileSystemObject")
	if fs.fileexists(file) then
		set f=fs.GetFile(file)
		diff = datediff( "n", f.DateLastModified, now())
	else
		diff = -1
	end if
	set f=nothing
	set fs=nothing
	TimeDiff = diff
End Function

' this function reads a file and returns its content as text.
' it takes one argument which is the complete file path.
' returns 0 if file doesnt exist.
Private Function ReadFile(file)
	dim fs,f,data
	set fs=CreateObject("Scripting.FileSystemObject")
	if fs.fileexists(file) then
		set f=fs.OpenTextFile(file,1)
		data = f.readall
		f.close
	else
		data = -1
	end if
	set f=nothing
	set fs=nothing
	ReadFile = data
End Function

' this function returns the size of a file in bytes.
' it takes one argument, the complete file path.
' returns 0 if file doesnt exist.
Private Function FileSize(file)
	dim fs,f,size
	set fs=CreateObject("Scripting.FileSystemObject")
	if fs.fileexists(file) then
		set f=fs.GetFile(file)
		size = f.size
	else
		size = -1
	end if
	set f=nothing
	set fs=nothing
	FileSize = size
End Function

' This function writes content to a text file.
' it takes two arguments the complete file path and the content to write.
' note that it overwrites the file everytime.
Sub WriteFile(file, content)
	dim fs,f
	set fs=CreateObject("Scripting.FileSystemObject")
	set f=fs.CreateTextFile(file,true)
	f.write(content)
	f.close
	set f=nothing
	set fs=nothing
End Sub

' this code originally from http://www.aspfaqs.com/aspfaqs/ShowFAQ.asp?FAQID=128
' and modified for: 
' - better error handling.
' - to use MSXML 3.0+
' - Content-Length (page size) checking before re-downloading.
' - setting user-agent string to Samurize.
' - support for retrieving partial-content with Range headers.
' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'        Function to return binary data
' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Private Function GetHTMLBin(strURL)
	
	Dim objXMLHTTP, strReturn, length, filelength, SamAgent, lengthr

	SamAgent = "Samurize Client Script http://www.samurize.com/" ' set the Samurize Agent header string.

    Set objXMLHTTP = CreateObject("MSXML2.ServerXMLHTTP") ' requires MSXML 3.0+

	On Error Resume Next
	objXMLHTTP.Open "HEAD", strURL, False ' using the HEAD HTTP method instead of GET to only download headers.
	objXMLHTTP.setrequestheader "User-Agent", SamAgent ' set Samruize agent
	objXMLHTTP.Send

	if err <> 0 then
		GetHTMLBin = OfflineMsg ' this message is returned if the script cant access the remote url.
	else
		length = CLng(objXMLHTTP.getResponseHeader("Content-Length")) ' Get url length in bytes.

		if RangeLByte <> 0 then ' if using Ranges
			filelength = CLng(ReadFile(savePath & FileName & ".length")) ' Read the temp-file Length from the .length file instead.
		else
			filelength = FileSize(savePath & FileName) ' get the temp-file size.
		end if

		if length <> "" AND length = filelength then ' and if they are the same
			GetHTMLBin = ReadFile(savePath & FileName) ' we read the temp-file without downloading.
			objXMLHTTP.abort ' and abort the connection.
'			GetHTMLBin = "same size"
		else
			objXMLHTTP.Open "GET", strURL, False ' re-initialize the object with GET to download document.
			objXMLHTTP.setrequestheader "User-Agent", SamAgent ' set Samruize agent
			if RangeLByte <> 0 then ' if using Ranges...
				objXMLHTTP.setrequestheader "Range", "bytes=" & RangeFByte & "-" & RangeLByte ' set the Range HTTP Header
			end if
			objXMLHTTP.Send
			if RangeLByte <> 0 then
				' next line gets the url length in bytes from the Content-Range header.
				lengthr = Mid(objXMLHTTP.getResponseHeader("Content-Range"), instr(objXMLHTTP.getResponseHeader("Content-Range"), "/") +1)
				WriteFile savePath & FileName & ".length", lengthr ' save to FileName.length
			end if
			GetHTMLBin = objXMLHTTP.responseBody ' download the document.
			WriteFile savePath & FileName, GetHTMLBin ' and save it.
'			GetHTMLBin = "not same size"
		end if
	end if
	On Error GoTo 0

    Set objXMLHTTP = Nothing
End Function

' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'        Function to convert binary data to text
' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Private Function BinToText(varBinData, intDataSizeInBytes)    ' as String
    		
	Const adFldLong = &H00000080
    Const adVarChar = 200
    Set objRS = CreateObject("ADODB.Recordset")

    objRS.Fields.Append "txt", adVarChar, intDataSizeInBytes, adFldLong
    objRS.Open

    objRS.AddNew
    objRS.Fields("txt").AppendChunk varBinData
    BinToText = objRS("txt").Value

    objRS.Close
    Set objRS = Nothing
End Function